Name: valgrind
Version: 2.1.2
%define cvsdate 20040522
Release: alt0.3.%cvsdate

Summary: Valgrind, an open-source memory debugger for x86-GNU/Linux
License: GPL
Group: Development/Other
URL: http://valgrind.kde.org/

%ifdef cvsdate
Source: %name-%cvsdate.tar.bz2
%else
Source: http://developer.kde.org/~sewardj/%name-%version.tar.bz2
%endif

Source1: find-requires.sh

Patch1: %name-2.1.2-alt-sigreturn.patch
Patch2: %name-2.1.2-alt-suppressions.patch
Patch3: %name-2.1.2-alt-intercept-strmem.patch
Patch4: %name-2.1.2-alt-direct-syscall.patch
Patch5: %name-2.1.2-alt-pad-check.patch

AutoProv: yes, nolib
%define __find_requires %SOURCE1

# Automatically added by buildreq on Wed May 05 2004
BuildRequires: XFree86-devel XFree86-libs gcc-c++ gdb glibc-devel-static

BuildPreReq: kernel-headers-std

%description
Valgrind is a GPL'd tool to help you find memory-management problems
in your programs.  When a program is run under Valgrind's supervision,
all reads and writes of memory are checked, and calls to
malloc/new/free/delete are intercepted.  As a result, Valgrind can
detect problems such as:

    * Use of uninitialised memory
    * Reading/writing memory after it has been free'd
    * Reading/writing off the end of malloc'd blocks
    * Reading/writing inappropriate areas on the stack
    * Memory leaks -- where pointers to malloc'd blocks are lost forever
    * Passing of uninitialised and/or unaddressible memory to system calls
    * Mismatched use of malloc/new/new [] vs free/delete/delete []
    * Some misuses of the POSIX pthreads API

%package devel
Summary: Valgrind header files for embedding Valgrind checks into other applications
Group: Development/Other
Requires: %name = %version-%release

%description devel
Valgrind-devel contains header files for providing macros to embed
Valgrind checks into other applications.  The resulting executables
will still run without Valgrind, just a little bit more slowly than
they otherwise would, but otherwise unchanged.

When run on Valgrind with --client-perms=yes, Valgrind observes these
macro calls and takes appropriate action.  When run on Valgrind with
--client-perms=no (the default), Valgrind observes these macro calls
but does not take any action as a result.

%prep
%setup -q %{?cvsdate:-n %name}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1 -b .alt-pad-check

%build
%{?cvsdate:./autogen.sh}
%configure
%make

%install
%make_install DESTDIR=%buildroot install

%__rm -f %buildroot%_bindir/%name
%__ln_s ../lib/%name/%name %buildroot%_bindir/%name

# workaround for trampoline handling problems in old versions of the Openwall
# kernel patch
chstk -e %buildroot%_libdir/%name/%name

# Valgrind shared libraries should not be stripped - see README_PACKAGERS
%set_strip_method executable

# Valgrind low-level routines really need to use %ebx - no chance to make them
# work with -fPIC
%set_verify_elf_method textrel=relaxed

%files
%_bindir/*
%_libdir/%name
%_libdir/pkgconfig/%name.pc
%doc docs/*.html */docs/*.html AUTHORS ACKNOWLEDGEMENTS FAQ.txt NEWS

%files devel
%_includedir/*

%changelog
* Wed Jun 02 2004 Sergey Vlasov <vsu@altlinux.ru> 2.1.2-alt0.3.20040522
- Fixed fcntl F_GETLK64, F_SETLK64, F_SETLKW64 handling in alt-direct-syscall
  patch.
- Added alt-pad-check patch: exit immediately if as_pad fails instead of
  mysteriously crashing later (can happen if hard address space limits are
  configured).

* Sat May 22 2004 Sergey Vlasov <vsu@altlinux.ru> 2.1.2-alt0.2.20040522
- 20040522 CVS snapshot:
  + teach Massif about the 'nothrow' versions of new and new[]
- Added alt-direct-syscall patch: make libpthread wrappers invoke syscalls
  directly instead of using __libc_* wrappers (which are no longer exported in
  recent glibc versions).

* Wed May 05 2004 Sergey Vlasov <vsu@altlinux.ru> 2.1.2-alt0.1.20040505
- 20040505 CVS snapshot.
- Filter out GLIBC_PRIVATE dependencies.
- Enable executable stack (workaround for GCC trampoline handling bug in the
  Openwall kernel patch).
- Added alt-sigreturn patch: workaround for signal return handling bug in the
  Openwall kernel patch.
- Added alt-suppressions patch: suppress false memcheck error in
  /lib/ld-2.3.3.so (strchr is over-optimized, and the intercept mechanism
  cannot replace it that early).
- Added alt-intercept-strmem patch: use the new intercept mechanism instead of
  symbol override for str*/mem* function replacement (symbol override does not
  work with glibc-2.3.3 because of PLT bypassing, and this leads to lots of
  false errors detected by memcheck).
- Updated BuildRequires.

* Sun Jan 04 2004 Sergey Vlasov <vsu@altlinux.ru> 2.0.0-alt1
- 2.0.0 stable release.
- Updated URL.
- Relaxed TEXTREL check (the low-level code cannot be made PIC).
- Updated BuildRequires.

* Wed Oct 08 2003 Sergey Vlasov <vsu@altlinux.ru> 2.0-alt0.20030725
- 20030725 snapshot.
- Added BuildPreReq: kernel-headers-std.

* Thu May 22 2003 Sergey Vlasov <vsu@altlinux.ru> 1.9.6-alt1
- 1.9.6 release.
- Updated BuildRequires.
- Fixed devel subpackage dependencies.
- Spec file cleanup.

* Thu Nov 21 2002 Sergey Vlasov <vsu@altlinux.ru> 1.0.4-alt1
- 1.0.4 release.
- Do not strip shared libraries.
- Added BuildRequires.

* Mon Jul 29 2002 Alexander Bokovoy <ab@altlinux.ru>
- Initial build.

